Index: bridges/bridge_multiplexed.c
===================================================================
--- bridges/bridge_multiplexed.c	(revision 334567)
+++ bridges/bridge_multiplexed.c	(working copy)
@@ -223,6 +223,9 @@
 		winner = ast_waitfor_nandfds(multiplexed_thread->chans, multiplexed_thread->service_count, &fds, 1, NULL, &outfd, &to);
 		multiplexed_thread->waiting = 0;
 		ao2_lock(multiplexed_thread);
+		if (multiplexed_thread->thread == AST_PTHREADT_STOP) {
+			break;
+		}
 
 		if (outfd > -1) {
 			int nudge;
@@ -234,7 +237,21 @@
 			}
 		}
 		if (winner && winner->bridge) {
-			ast_bridge_handle_trip(winner->bridge, NULL, winner, -1);
+			struct ast_bridge *bridge = winner->bridge;
+			int stop = 0;
+			ao2_unlock(multiplexed_thread);
+			while ((bridge = winner->bridge) && ao2_trylock(bridge)) {
+				sched_yield();
+				if (multiplexed_thread->thread == AST_PTHREADT_STOP) {
+					stop = 1;
+					break;
+				}
+			}
+			if (!stop && bridge) {
+				ast_bridge_handle_trip(bridge, NULL, winner, -1);
+				ao2_unlock(bridge);
+			}
+			ao2_lock(multiplexed_thread);
 		}
 	}
 
